# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Chooser.
# 
# Chooser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Chooser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Chooser.  If not, see <http://www.gnu.org/licenses/>.

from tkFileDialog import *
from hydra.view_holder import  ViewHolder
from text_view import *
from info_view import *
from choice_view import *
from undo_controler import *
from hydra.observer_context import Context
from model import Model,  All,  NotChosen,  Ambiguous,  MatchWord,  Phantom
from hydra.synset_view import SynsetView
from find_window import FindDialog
from edit_window import EditDialog
from word import  Word
#from hydra.ling_view import LingView
BIT_CTRL = 4
version = 0.12;
class Main(Context,  Frame):
    filetypes = (('Chooser File', '*.txt'), ('Any File', '*.*'))
    time = 200000
    def __init__(self, master = None):
        Frame.__init__(self,  master)
#		self.master = master
        self.pack(expand = 1,  fill = BOTH)
        Context.__init__(self)
        self.cancel_id = None
        self.create_widgets()
#		model = Model('/home/boby/python/chooser/ch.txt')
    def on_select(self):
        self.text_view.next()
    def create_widgets(self):
        self.create_menu();
        
        self.view_frame = PanedWindow(self,  orientation = VERTICAL)
        self.view_frame.pack(expand = 1,  fill = BOTH)
        self.ptop = self.view_frame.add('top',  expand = 1)
        self.pbottom = self.view_frame.add('bottom',  expand = 1)
        
        self.top_view_frame = PanedWindow(self.ptop, orientation = HORIZONTAL,  height = 300)
        self.top_view_frame.pack(expand = 1,  fill = BOTH)
        
#		self.view_frame.pack(expand = 1, fill = BOTH, side = TOP, anchor = N)
        self.pleft = self.top_view_frame.add('left',  expand = 1)
        self.pright = self.top_view_frame.add('right', expand = 1)
        
        self.text_view = TextView(self.pleft,  self)
        self.text_view.pack(fill = BOTH,  expand = 1)
        
        
#		self.info_view = InfoView(self.pright,  self)
#		self.info_view = SynsetView(self,  self.pright)
        self.info_view = ViewHolder( self.pright,  self,  False)
        self.info_view.pack(expand = 1,  fill = BOTH)
#
        self.choice_view = ChoiceView(self.pbottom,  self)
        self.choice_view.pack(expand = 1,  fill = BOTH)
        
        self.attach(self.text_view,  VM.Edit|VM.Select)
        self.text_view.attach(self.choice_view)
        self.text_view.attach(self)
        self.choice_view.attach(self.info_view)
        
        #find dialog
        self.find_dialog = FindDialog(self.master,  self._find)
        
        self.model = None
        self.var_end = IntVar()
#		self.set_model(Model(''))
#		self.model = None
        self.master.protocol("WM_DELETE_WINDOW", self.on_close)
        self.choice_view.focus_set()
    def create_menu(self):
        self.menu = menu = Menu(self.master)
        self.master.config(menu=menu)
        self.filemenu = fm = Menu(menu)
        menu.add_cascade(label="File", menu=fm, underline = 0)
        fm.add_command(label = u"Open", command = self.load, underline = 0)
        fm.add_command(label = u"Save", command = self.save, state = DISABLED, underline = 0)
        fm.add_command(label = u"Save as", command = self.save_as, state = DISABLED, underline = 1)
        
    def iterate(self,  iterator):
        self.iterator = iterator
        self.model.set_iterator(iterator,  self.iterate_current.get(),  self.iterate_sense.get())
    
    def iterate_ends(self):
        self.model.set_iterator(MatchWord,  False,  Word('[.?!]$',  None,  None))
    
    def load(self):
        filename = askopenfilename(parent = self.master, filetypes = self.filetypes)
        if filename:
            model = Model(filename)
            title = "Chooser: " + filename
            self.set_model(model,  not bool(self.model))
            self.master.title(title)
    def refresh(self, message):
        print 'refresh'
        try:
            value = self.model.current().end
            print value
            self.var_end.set(value)
#            print self.var_end.get()
#            print self.var_end
        except:
            import traceback
            traceback.print_exc()
        self.notify(message)
    def save(self):
        self.model.save()
    def save_as(self):
        filename = asksaveasfilename(parent = self.master, defaultextension = ".xml", initialfile = self.model.filename, filetypes = self.filetypes)
        if filename:
            self.model.save(filename)
            self.master.title(filename)
    def auto_save(self):
        self.model.save()
        self.aim()
    def on_close(self):
        if askokcancel("Close", "Are you sure?", parent = self.master):
            if self.cancel_id:
                self.master.after_cancel(self.cancel_id)
            self.master.destroy()
    def aim(self):
        self.cancel_id = self.master.after(self.time, self.auto_save)
    def enable_menus(self):
        self.filemenu.entryconfigure(2, state = NORMAL)
        self.filemenu.entryconfigure(3, state = NORMAL)
        
        #Pass menu
        self.iterate_current = IntVar()
        self.iterate_sense = IntVar()
        self.pass_menu = pm = Menu(self.menu)
        self.menu.add_cascade(label = 'Pass',  menu = pm,  underline = 0)
        pm.add_radiobutton(label = u'All',  command = lambda: self.iterate(All),  underline = 0)
        pm.add_radiobutton(label = u'Not chosen',  command = lambda: self.iterate(NotChosen),  underline = 0)
        pm.add_radiobutton(label = u'Ambiguous',  command = lambda: self.iterate(Ambiguous),  underline = 0)
        pm.add_radiobutton(label = u'Sentence Ends',  command = self.iterate_ends,  underline = 0)
        pm.add_radiobutton(label = u'Phantom',  command = lambda: self.iterate(Phantom),  underline = 0)
        pm.add_separator()
        cb = pm.add_checkbutton(label = u'Current Word', command = lambda: self.iterate(self.iterator),  variable = self.iterate_current,  underline = 8)
        cb = pm.add_checkbutton(label = u'Current Sense', command = lambda: self.iterate(self.iterator),  variable = self.iterate_sense,  underline = 9)
        
        self.pass_menu.invoke(1)
        
        #Find menu
        self.find_menu = fm = Menu(self.menu)
        
        self.menu.add_cascade(label = u'Word', menu = fm,  underline = 0)
        fm.add_command(label = u'Find',  accelerator = 'Ctrl+F3',  underline = 0,  command = self.find)
        fm.add_command(label = u'Find Again', accelerator = 'F3',  underline = 5,  command = self.find_again)
        fm.add_separator()
        fm.add_command(label = u'Edit', accelerator = 'F4', underline = 0,  command = self.edit)
        fm.add_command(label = u'Insert',  underline = 0,  command = self.insert)
        fm.add_command(label = u'Delete',  accelerator = 'Del',  underline = 0, command = self.delete)
        fm.add_command(label = u'Append',  underline = 1,  command = self.append)
        
        self.winfo_toplevel().bind('<F3>',  self.find_acc)
        self.winfo_toplevel().bind('<F4>',  self.edit)
#		self.winfo_toplevel().bind('',  self.find_acc)
#		self.winfo_toplevel().bind('F',  self.find_acc)
        self.winfo_toplevel().bind('<Delete>',  self.delete)
        # Stats
        self.menu.add_command(label = u'Stats',  command = self.stats)
        print 'self',  self
        self.menu.add_checkbutton(label = u'End',  command = self.set_end,  variable=self.var_end)
    
    def set_end(self):
        end =  self.var_end.get()
        word = self.model.current().set_end(bool(end))
    
    def stats(self):
        stats = self.model.stats()
        print 
        print 'Statistics:'
        for stat in stats:
            print stat,  ':',  stats[stat]
        print
#Edit
    def append(self):
        insert_dialog = EditDialog(self,  Word('',  '',  None),  self._append)
    def _append(self,  insert_dialog):
        word = self.model.append(insert_dialog.form(),  insert_dialog.lemma())
        self.refresh(VMessage(word,  VM.Edit))
    def delete(self,  event = None):
        if askokcancel("Delete", "Are you sure?", parent = self.master):
            self.model.delete()
            self.refresh(VMessage(None,  VM.Edit))
    def insert(self):
        insert_dialog = EditDialog(self,  Word('',  '',  None),  self._insert)
    def _insert(self,  insert_dialog):
        word = self.model.insert(insert_dialog.form(),  insert_dialog.lemma())
        self.refresh(VMessage(word,  VM.Edit))
    def edit(self,  event = None):
        edit_dialog = EditDialog(self.master,  self.model.current(),  self._edit)
    def _edit(self,  edit_dialog):
        word = edit_dialog.word

        word.lemma = edit_dialog.lemma()
        word.word = edit_dialog.form()
        
        self.refresh(VMessage(word,  VM.Edit))
#Find 
    def find_acc(self,  event):
        if event.state & BIT_CTRL:
            self.find()
        else:
            self.find_again()
    def find_again_acc(self,  event):
        self.find_again()
    def find(self):
        self.find_dialog.show()
    def find_again(self):
        if self.find_dialog.value():
            self._find(self.find_dialog)
        else:
            self.find()
    def _find(self,  find_dialog):
        if find_dialog.by_lemma():
            word = Word(None,  find_dialog.value(),  None)
        else:
            word = Word(find_dialog.value(), None,  None)
        return self.text_view.find(word,  find_dialog.case_sensitive(),  find_dialog.direction())

    def set_model(self, model,  enable = True):
        self.model = model
        
        self.text_view.set_model(model)
        if enable:
            self.enable_menus()
        else:
            self.iterate(self.iterator)
        self.aim()
if __name__== '__main__':
    master = Tk()
    main = Main(master)
    master.title("Chooser")
    main.mainloop()
    print "That's all folks for version", version
