# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Chooser.
# 
# Chooser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Chooser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Chooser.  If not, see <http://www.gnu.org/licenses/>.

from Tix import *
from tkSimpleDialog import Dialog
#import tkSimpleDialog
from word import Word


class EditDialog(Dialog):
		def __init__(self,  master,  word,  callback,  title = 'Edit'):
			self.callback = callback
			self.word = word
			Dialog.__init__(self,  master,  title)
		
		def body(self,  master):
			Label(master,  text = 'form:').grid(padx = 10,  sticky = E)
			
			self.form_entry = Entry(master)
			self.form_entry.grid(padx = 5,  row = 0,  column = 1,  sticky = W)
			self.form_entry.insert(0,  self.word.form())
			
			Label(master,  text = 'lemma:').grid(padx = 10, sticky = E)
			
			self.lemma_entry = Entry(master)
			self.lemma_entry.grid(padx = 5,  row = 1,  column = 1,  sticky = W)
			self.lemma_entry.insert(0,  self.word.literal())
			
			return self.form_entry
		def apply(self):
			self.callback(self)
		
		def validate(self):
			return self.form() and self.lemma()
		
		def form(self):
			return self.form_entry.get()
		
		def lemma(self):
			return self.lemma_entry.get()

if __name__ == '__main__':
	x = Tk()
	def cmd():
		tl = EditDialog(x, Word('word1', 'lemma1', None), 'Edit')
	Button(text = 'test',  command = cmd).pack()
	x.mainloop()



